<!DOCTYPE html>
<html>

<head>
  <title> Tạo đơn hàng - dành cho Admin </title>
  <meta charset='utf-8'>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container jumbotron py-4">
    <h1 class="text-center mb-5"> Create Pizza Order - For Admin </h1>
    <div class="form-group row">
      <label for="" class="col-sm-2 col-form-label">Cỡ Combo</label>
      <div class="col-sm-4">
        <select id="select-size" class="form-control">
          <option value="NOT_SELECT_COMBO"> Chọn cỡ Combo (Combo size)</option>
          <option value="S"> Nhỏ</option>
          <option value="M"> Vừa</option>
          <option value="L"> Lớn</option>
        </select>
      </div>
      <label for="" class="col-sm-2 col-form-label">Đồ uống</label>
      <div class="col-sm-4">
        <select class="form-control" id="select-drink">
          <option value="NOT_SELECT_DRINK">Chọn đồ uống</option>
        </select>
      </div>
    </div>
    <div class="form-group row">
      <label class="col-sm-2 col-form-label">Mã voucher</label>
      <div class="col-sm-4">
        <input id="input-voucher" type="text" class="form-control" placeholder="Voucher ID (mã voucher)">
      </div>
      <label class="col-sm-2 col-form-label">Loại pizza</label>
      <div class="col-sm-4">
        <select class="form-control" id="select-pizza">
          <option value="NOT_SELECT_PIZZA"> Chọn loại pizza </option>
          <option value="Seafood"> Hải sản</option>
          <option value="Hawaii"> Ha wai </option>
          <option value="Bacon"> Thịt hun khói </option>
        </select>
      </div>
    </div>
    <div class="form-group row">
      <label class="col-sm-2 col-form-label" for="">Họ và tên</label>
      <div class="col-sm-4">
        <input id="input-name" type="text" class="form-control" placeholder="Họ và tên">
      </div>
      <label for="" class="col-sm-2 col-form-label">Email</label>
      <div class="col-sm-4">
        <input id="input-email" type="email" class="form-control" placeholder="Email">
      </div>
    </div>
    <div class="form-group row">
      <label class="col-sm-2 col-form-label">Số điện thoại</label>
      <div class="col-sm-4">
        <input id="input-mobile" type="text" class="form-control" placeholder="Số điện thoại">
      </div>
      <label class="col-sm-2 col-form-label">Địa chỉ</label>
      <div class="col-sm-4">
        <input id="input-adress" type="text" class="form-control" placeholder="Địa chỉ">
      </div>
    </div>
    <div class="form-group row">
      <label class="col-sm-2 col-form-label">Lời nhắn</label>
      <div class="col-sm-10">
        <textarea id="input-message" class="form-control" placeholder="Lời nhắn"></textarea>
      </div>
    </div>
    <div class="form-group text-right">
      <button class="btn btn-primary" onclick="onBtnCreateOrderClick()">Create Order</button>
    </div>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201; // status 201 - tạo thành công
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      // load dữ liệu vào select car
      loadDataDrinkList();
    }
    function onBtnCreateOrderClick() {
      //khai báo đối tượng
      var vOrderObj = {
        kichCo: "",
        duongKinh: "",
        suon: "",
        salad: "",
        loaiPizza: "",
        idVourcher: "",
        idLoaiNuocUong: "",
        soLuongNuoc: "",
        thanhTien: "",
        hoTen: "",
        email: "",
        soDienThoai: "",
        diaChi: "",
        loiNhan: "",
      }
      //B1 thu thập dữ liệu đưa vào obj
      thuThapDuLieuOrder(vOrderObj);
      //B2 kiểm tra dữ liệu
      var vDuLieuHopLe = kiemTraDuLieuOrder(vOrderObj);
      if (vDuLieuHopLe) {
        var vXmlHttpCreateOrder = new XMLHttpRequest();
        //B3 gọi api tạo đơn hàng
        goiApiTaoOrder(vOrderObj, vXmlHttpCreateOrder);
        vXmlHttpCreateOrder.onreadystatechange =
          function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_CREATE_SUCCESS) { // status 201 tao thanh cong
             xuLyHienThiTaoOrder(vXmlHttpCreateOrder);
            }
          }
      }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thực hiện call api để load dữ liệu vào drink list
    function loadDataDrinkList() {
      var vXhttp = new XMLHttpRequest();
      vXhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      vXhttp.send();
      vXhttp.onreadystatechange = function () {
        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
          console.log(vXhttp.responseText); // ghi response text ra console.log
          handleLoadDataToSelectDrink(vXhttp);
        }
      };
    }

    // handle data load to select drink
    function handleLoadDataToSelectDrink(paramXhttp) {
      var vArrayDrinkList = JSON.parse(paramXhttp.responseText);
      console.log("array drink list = " + vArrayDrinkList.length);
      // load data to drink select
      var vElementSelectDrink = document.getElementById("select-drink");
      for (var bIterator = 0; bIterator < vArrayDrinkList.length; bIterator++) {
        var bDrinkOptionElement = document.createElement("option");
        bDrinkOptionElement.value = vArrayDrinkList[bIterator].maNuocUong;
        bDrinkOptionElement.text = vArrayDrinkList[bIterator].tenNuocUong;
        vElementSelectDrink.appendChild(bDrinkOptionElement);
      }
    }
    function thuThapDuLieuOrder(paramOrderObj) {
      var vSelectSize = document.getElementById("select-size");
      var vSelectDrink = document.getElementById("select-drink");
      var vSelectPizza = document.getElementById("select-pizza");
      var vInpVoucher = document.getElementById("input-voucher");
      var vInpName = document.getElementById("input-name");
      var vInpEmail = document.getElementById("input-email");
      var vInpMobile = document.getElementById("input-mobile");
      var vInpAdress = document.getElementById("input-adress");
      var vInpMessage = document.getElementById("input-message");
      paramOrderObj.kichCo = vSelectSize.value;
      paramOrderObj.idLoaiNuocUong = vSelectDrink.value;
      paramOrderObj.loaiPizza = vSelectPizza.value;
      paramOrderObj.idVourcher = vInpVoucher.value.trim();
      paramOrderObj.hoTen = vInpName.value.trim();
      paramOrderObj.email = vInpEmail.value.trim();
      paramOrderObj.soDienThoai = vInpMobile.value.trim();
      paramOrderObj.diaChi = vInpAdress.value.trim();
      paramOrderObj.loiNhan = vInpMessage.value.trim();
      if (paramOrderObj.kichCo == "S") {
        paramOrderObj.duongKinh = 20;
        paramOrderObj.suon = 2;
        paramOrderObj.salad = 200;
        paramOrderObj.soLuongNuoc = 2;
        paramOrderObj.thanhTien = 150000;
      }
      if (paramOrderObj.kichCo == "M") {
        paramOrderObj.duongKinh = 24;
        paramOrderObj.suon = 4;
        paramOrderObj.salad = 300;
        paramOrderObj.soLuongNuoc = 3;
        paramOrderObj.thanhTien = 200000;
      }
      if (paramOrderObj.kichCo == "L") {
        paramOrderObj.duongKinh = 30;
        paramOrderObj.suon = 8;
        paramOrderObj.salad = 500;
        paramOrderObj.soLuongNuoc = 4;
        paramOrderObj.thanhTien = 250000;
      }
    }
    function kiemTraDuLieuOrder(paramOrderObj) {
      if (paramOrderObj.kichCo == "NOT_SELECT_COMBO") {
        alert("Chưa chọn size pizza");
        return false;
      }
      if (paramOrderObj.idLoaiNuocUong == "NOT_SELECT_DRINK") {
        alert("Chưa chọn loại nước uống");
        return false;
      }
      if (paramOrderObj.loaiPizza == "NOT_SELECT_PIZZA") {
        alert("Chưa chọn loại Pizza");
        return false;
      }
      if (paramOrderObj.idVourcher == "") {
        alert("Chưa nhập voucher");
        return false;
      }
      if (paramOrderObj.hoTen == "") {
        alert("Chưa nhập họ tên");
        return false;
      }
      if (paramOrderObj.email == "") {
        alert("Chưa nhập email");
        return false;
      }
      if (paramOrderObj.soDienThoai == "") {
        alert("Chưa nhập số điện thoại");
        return false;
      }
      if (paramOrderObj.diaChi == "") {
        alert("Chưa nhập địa chỉ");
        return false;
      }
      if (paramOrderObj.loiNhan == "") {
        alert("Chưa nhập lời nhắn");
        return false;
      }
      return true;
    }
    function goiApiTaoOrder(paramOrderObj, paramXhttp) {
      const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
      paramXhttp.open("POST", vBASE_URL, true);
      paramXhttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
      paramXhttp.send(JSON.stringify(paramOrderObj));
    }
    function xuLyHienThiTaoOrder(paramXhttp){
      console.log(paramXhttp.responseText);
      alert("Tạo đơn hàng thành công");
      window.location.href = "indexListView.html";
    }
  </script>


</body>

</html>